
/*
 *  Copyright (C) 2010-2016 Oracle Corporation
 *
 *  This file is part of the VirtualBox SDK, as available from
 *  http://www.virtualbox.org.  This library is free software; you can
 *  redistribute it and/or modify it under the terms of the GNU Lesser General
 *  Public License as published by the Free Software Foundation, in version 2.1
 *  as it comes in the "COPYING.LIB" file of the VirtualBox SDK distribution.
 *  This library is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 *
 * IStorageDeviceChangedEvent.java
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl (VirtualBox's interface definitions in XML)
 * Generator: src/VBox/Main/glue/glue-java.xsl
 */

package org.virtualbox_4_2;

import org.virtualbox_4_2.jaxws.*;
import javax.xml.ws.*;
import java.util.List;

/**

      Notification when a
      {@link org.virtualbox_4_2.IMachine#getMediumAttachments()}
      is attached or removed.
    
Interface ID: <tt>{8A5C2DCE-E341-49D4-AFCE-C95979F7D70C}</tt>
*/
public class IStorageDeviceChangedEvent extends IEvent {

    public IStorageDeviceChangedEvent(String wrapped, ObjectRefManager objMgr, VboxPortType port)
    {
        super(wrapped, objMgr, port);
    }
/**

        Storage device that is subject to change.
      
@return org.virtualbox_4_2.IMediumAttachment

*/
    public org.virtualbox_4_2.IMediumAttachment getStorageDevice() {
        this.getObjMgr().preventObjRelease();
        try
        {
         org.virtualbox_4_2.jaxws.IMediumAttachment retVal = port.iStorageDeviceChangedEventGetStorageDevice(obj);
         return (retVal != null) ? new org.virtualbox_4_2.IMediumAttachment(retVal, getObjMgr(), port) : null;
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e, e.getMessage());
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e, e.getMessage());
        }
        finally
        {
            getObjMgr().allowObjRelease();
        }
    }
/**

        Flag whether the device was removed or added to the VM.
      
@return Boolean

*/
    public Boolean getRemoved() {
        try
        {
         Boolean retVal = port.iStorageDeviceChangedEventGetRemoved(obj);
         return retVal;
        }
        catch (InvalidObjectFaultMsg e)
        {
            throw new VBoxException(e, e.getMessage());
        }
        catch (RuntimeFaultMsg e)
        {
            throw new VBoxException(e, e.getMessage());
        }
    }
    public static IStorageDeviceChangedEvent queryInterface(IUnknown obj) {
       return obj == null ?  null : new IStorageDeviceChangedEvent(obj.getWrapped(), obj.getObjMgr(), obj.getRemoteWSPort());
    }
}
